#include "temporary.h"

void timer_6_1us_int(void)
{
	TIM_TimeBaseInitTypeDef TIMER_InitStructure;
	NVIC_InitTypeDef  NVIC_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);
	TIM_TimeBaseStructInit(&TIMER_InitStructure);
	
	TIMER_InitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIMER_InitStructure.TIM_Period = 16;
	TIMER_InitStructure.TIM_Prescaler = 1;
	TIM_TimeBaseInit(TIM6, &TIMER_InitStructure);
	
	NVIC_InitStructure.NVIC_IRQChannel = TIM6_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	TIM_SelectOnePulseMode(TIM6, TIM_OPMode_Single);
	TIM_ITConfig(TIM6, TIM_IT_Update,ENABLE);
}

void timer_6_wait(uint32_t n_usec)
{	
	extern uint8_t f_timer_6_end;
	
	if(n_usec <= 4000)
	{
		TIM6->PSC = 0;
		TIM6->ARR = (uint16_t)(16 * n_usec);
		TIM_Cmd(TIM6, ENABLE);
	}
	else
	{
		TIM6->PSC = 1000 - 1;
		TIM6->ARR = (uint16_t)(16 * (n_usec / 1000));
		TIM_Cmd(TIM6, ENABLE);
	}
	
	while(f_timer_6_end == 0){}
	f_timer_6_end = 0;
}

