#include "hd44780.h"
#include "temporary.h"

void hd44780_init(void)
{
	send_DB_0_7_lines(0); 
	clear_RW();
	clear_RS();
	clear_E();
	timer_6_wait(40000);
	
	send_DB_0_7_lines(0x30);
	timer_6_wait(5000);
	blink_E();
	timer_6_wait(160);
	blink_E();
	timer_6_wait(160);
	blink_E();
	timer_6_wait(160);
	
	send_DB_0_7_lines(0x38);
	blink_E();
	timer_6_wait(160);
	
	
	hd44780_command(0x10);
	hd44780_command(0x0C);
	hd44780_command(0x06);
}

void hd44780_command(uint8_t lcdcmnd)
{
	timer_6_wait(40);
	send_DB_0_7_lines(lcdcmnd);
	clear_RS();
	clear_RW();
	blink_E();
	if(lcdcmnd < 2)
	{
		timer_6_wait(1700);
	}
}

void send_DB_0_7_lines(uint8_t command)
{
	if((command & 1) == 1)
	{
		set_DB0();
	}
	else
	{
		clear_DB0();
	}
	
	if(((command >> 1) & 1) == 1)
	{
		set_DB1();
	}
	else
	{
		clear_DB1();
	}
	
	if(((command >> 2) & 1) == 1)
	{
		set_DB2();
	}
	else
	{
		clear_DB2();
	}
	
	if(((command >> 3) & 1) == 1)
	{
		set_DB3();
	}
	else
	{
		clear_DB3();
	}
	
	if(((command >> 4) & 1) == 1)
	{
		set_DB4();
	}
	else
	{
		clear_DB4();
	}
	
	if(((command >> 5) & 1) == 1)
	{
		set_DB5();
	}
	else
	{
		clear_DB5();
	}
	
	if(((command >> 6) & 1) == 1)
	{
		set_DB6();
	}
	else
	{
		clear_DB6();
	}
	
	if(((command >> 7) & 1) == 1)
	{
		set_DB7();
	}
	else
	{
		clear_DB7();
	}
}

void blink_E(void)
{
	set_E();
	timer_6_wait(1);
	clear_E();
}

void hd44780_goto(uint8_t x, uint8_t y)
{
  uint8_t addr;
 
  switch (y)
  {
  case 0:
    addr = 0x80;
    break;
  case 1:
    addr = 0xC0;
    break;
  case 2:
    addr = 0x94;
    break;
  default:
    addr = 0xD4;
    break;
  }
  addr = addr + x;
  hd44780_command(addr);
}

void hd44780_char(uint8_t ldata)
{
	set_RS();
	clear_RW();
	
	timer_6_wait(40);
	send_DB_0_7_lines(ldata);
	blink_E();
}

void hd44780_write(char ldata[])
{
  char k=0;
 
	set_RS();
	clear_RW();
 
  while(ldata[k] != 0)
  {
		timer_6_wait(40);
    send_DB_0_7_lines(ldata[k]);
    blink_E();
    k++;
  }
}
