#include "hd44780.h"
#include "temporary.h"

void hd44780_init_4_bit(void)
{
	send_DB_0_7_lines(0); 
	clear_RW();
	clear_RS();
	clear_E();
	timer_6_wait(40000);
	
	send_DB_4_7_lines(3);
	timer_6_wait(5000);
	blink_E();
	timer_6_wait(160);
	blink_E();
	timer_6_wait(160);
	blink_E();
	timer_6_wait(160);
	
	send_DB_4_7_lines(2);
	blink_E();
	timer_6_wait(160);
	
	hd44780_command_4_bit(0x28);
	hd44780_command_4_bit(0x10);
	hd44780_command_4_bit(0x0C);
	hd44780_command_4_bit(0x06);
}

void hd44780_command_4_bit(uint8_t lcdcmnd)
{
	timer_6_wait(40);
	clear_RS();
	clear_RW();
	send_DB_4_7_lines(lcdcmnd >> 4);
	blink_E();
	send_DB_4_7_lines(lcdcmnd);
	blink_E();
	if(lcdcmnd < 2)
	{
		timer_6_wait(1700);
	}
}

void send_DB_4_7_lines(uint8_t command)
{
	if((command & 1) == 1)
	{
		set_DB4();
	}
	else
	{
		clear_DB4();
	}
	
	if(((command >> 1) & 1) == 1)
	{
		set_DB5();
	}
	else
	{
		clear_DB5();
	}
	
	if(((command >> 2) & 1) == 1)
	{
		set_DB6();
	}
	else
	{
		clear_DB6();
	}
	
	if(((command >> 3) & 1) == 1)
	{
		set_DB7();
	}
	else
	{
		clear_DB7();
	}
}

void hd44780_goto_4_bit(uint8_t x, uint8_t y)
{
  uint8_t addr;
 
  switch (y)
  {
  case 0:
    addr = 0x80;
    break;
  case 1:
    addr = 0xC0;
    break;
  case 2:
    addr = 0x94;
    break;
  default:
    addr = 0xD4;
    break;
  }
  addr = addr + x;
  hd44780_command_4_bit(addr);
}

void hd44780_char_4_bit(uint8_t ldata)
{
	set_RS();
	clear_RW();
	timer_6_wait(40);
	send_DB_4_7_lines(ldata >> 4);
	blink_E();
	send_DB_4_7_lines(ldata);
	blink_E();
}

void hd44780_write_4_bit(char ldata[])
{
  char k=0;
 
	set_RS();
	clear_RW();
 
  while(ldata[k] != 0)
  {
		timer_6_wait(40);
    send_DB_4_7_lines(ldata[k] >> 4);
    blink_E();
		send_DB_4_7_lines(ldata[k]);
    blink_E();
    k++;
  }
}

